import { DataModel } from '../../entities/DataModel';
import { Component, Input } from '@angular/core';
import { FormGroup }        from '@angular/forms';

import { FieldBase }     from './field-base';
import { GroupBase } from '../../form/dynamic-form-group/group-base';


@Component({
    selector: 'df-field',
    templateUrl: './dynamic-form-field.component.html'
})

export class DynamicFormFieldComponent {
    @Input() dataModel: DataModel;
    @Input() field: FieldBase<any>;
    @Input() form: FormGroup;
  
    get isValid() { 
      return true; //return this.form.controls[this.field.key].valid; 
    }

  

    ruleVisibleMethod(field, rule, dataModel){ //visibility rule -- checks if target field is visible
        dataModel.fields.forEach(fld => {
            if (fld.label == rule._target && fld.visible == true)
                field.visible = true;

        });
        if(field.visible == true)
            return true;
      }
      FieldValueRuleMethod(field, rule){ //fieldValue  rule -- checks the value of target
        if (rule._ruleStyle == "range"){
            this.dataModel.fields.forEach(fld => {
                if (fld.key == rule._target && rule._from< fld.value <rule._to){
                    console.log("visible"+ fld.value)
                    field.visible = true;
                }
    
            });
        }
        if (rule._ruleStyle == "boolean"){ //boolean Decision field
            let ruleValue = rule.value.__text;            
            if (field.value.value.toString() == ruleValue){
                this.dataModel.getFieldByKey(rule._target).visible = true;
            }else{
                this.dataModel.getFieldByKey(rule._target).visible = false;
            }
        }
        if (rule._ruleStyle == "checked"){  //checkbox field     
            if (field.value == true){
                this.dataModel.getFieldByKey(rule._target).visible = true;
            }else{
                this.dataModel.getFieldByKey(rule._target).visible = false;
            }
        }
      }

      toggleVisibility(e, field, ckb){  
         console.log(field);debugger;
         if(ckb)
            field.value = ckb.checked;
         field.rules.forEach(rule => {
             if (rule._type=="fieldValue"){
                this.FieldValueRuleMethod(field, rule);
             }
         });        

      }
}